(ns actuarial.basic)
(import [weka.core Statistics])

(defn normalcdf "Normal CDF" [a] (Statistics/normalProbability a))
(defn normalvar "Normal VAR" [a] (Statistics/normalInverse a))
(def infinity Double/POSITIVE_INFINITY)

(defn binomial-coefficient [n k]
  (let [rprod (fn [a b] (reduce * (range a (inc b))))]
    (/ (rprod (- n k -1) n) (rprod 1 k))))

;; from https://gist.github.com/the-max0r/d5affa7c3c8a481733e5
(defn rootNP
  "Newton Raphson univariate root"
  [f x]
  (def step 1E-4)
  (def eps 1E-8)
  (let [m (/ (- (f (+ x step)) (f x)) step)
        b (- (f x) (* m x))
        x-0 (- (/ b m))]
    (if (<= (Math/abs (- x x-0)) eps)
      x-0
      (recur f x-0))
    ))