(ns actuarial.http 
  (:use ring.adapter.jetty)
  (:use ring.middleware.params)
  (:use actuarial.distributions))

(require 'ring.middleware.stacktrace)

;(describe (build-distribution (resolve (symbol (str "gaussian" "-dist"))) [1 3]) 0.5 0.25 3)

(defn wrap-spy [handler]
  (fn [request]
    (println "-------------------------------")
    (println "Incoming Request:")
    (clojure.pprint/pprint request)
    (let [response (handler request)]
      (println "Outgoing Response Map:")
      (clojure.pprint/pprint response)
      (println "-------------------------------")
      response)))

(defmacro get-map-dist [map name param]
  `(apply (get ~map ~name ) ~param))

(defn handler [req]
  (let [distr-name (get-in req [:query-params "dist"])
        distr-params (read-string (get-in req [:query-params "params"]))
        distr-x (read-string (get-in req [:query-params "x"] "0"))
        distr-d (read-string (get-in req [:query-params "d"] "0"))
        distr-t (read-string (get-in req [:query-params "t"] "1"))
        distr-map (get-map-dist distributions-map distr-name distr-params)
        sortie (describe distr-map distr-x distr-d distr-t)
        ]
    (println distr-name distr-params)
    {:status 200
     :headers {"Content-Type" "text/html"}
     :body (str "<p>" sortie "<p>")}
  ))

(def app
  (-> #'handler
    (ring.middleware.stacktrace/wrap-stacktrace)
    (wrap-spy)
    (wrap-params)
    ))

(defonce server (ring.adapter.jetty/run-jetty #'app {:port 8080 :join? false}))

(.stop server)

(.start server)